//
//  FlickriumPlugin.m
//  Flickrium
//
//  otool -hV Library/Application\ Support/Adium\ 2.0/PlugIns/Flickrium.AdiumPlugin/Contents/MacOS/Flickrium
//
//  Created by matee on 1/18/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "FlickriumPlugin.h"
#import "FlickriumPluginPreferences.h"
#import <AIUtilities/AIDictionaryAdditions.h>
#import <Adium/ESDebugAILog.h>
#import <Adium/AIContentMessage.h>
#import "FlickrAPIkey.h"
#import "FlickrUrlDetector.h"


@implementation FlickriumPlugin {
	AIPreferencePane *FlickriumPluginPrefs;
	int photoCounter;
	NSString *flickriumJs;
}

- (NSString *)pluginAuthor
{
	return @"Mateusz Pawlik";
}

- (NSString *)pluginVersion
{
	return @"0.1";
}

- (NSString *)pluginDescription
{
	return @"This plugin shows flickr photos right inside the chat window.";
}

- (NSString *)pluginURL
{
	return @"http://adiumxtras.com/index.php?a=xtras&xtra_id=XXX";
}

- (void)installPlugin
{
	NSLog(@"Installing plugin - Flickrium");
	FlickriumPluginPrefs = [[FlickriumPluginPreferences preferencePaneForPlugin:self] retain];
	photoCounter = 0; // Unsigned long
	
	NSDictionary *defaults = [NSDictionary dictionaryNamed:@"FlickriumPluginDefaults"
												  forClass:[self class]];
	
	/* load flickrium.js */
	NSLog(@"Loading flickrium.js");
	NSBundle *thisBundle = [NSBundle bundleForClass:[self class]];
	NSString *flickriumJsPath = [thisBundle pathForResource:@"flickrium" ofType:@"js"];
	flickriumJs = [NSString stringWithContentsOfFile: flickriumJsPath encoding:NSUTF8StringEncoding error:nil];
	NSLog(@"Loaded %@: %@", flickriumJsPath, flickriumJs);
	/* loaded flickrium.js */
	
	if (defaults) {
		[[adium preferenceController] registerDefaults:defaults forGroup:PREF_GROUP_FLICKRIUM];
	} else {
		NSLog(@"FlickriumPlugin: Failed to load defaults.");
	}
	
	[[adium contentController] registerHTMLContentFilter:self direction:AIFilterOutgoing];
	[[adium contentController] registerHTMLContentFilter:self direction:AIFilterIncoming];
	NSLog(@"Flickrium - installed");
}

- (void)uninstallPlugin
{
	[flickriumJs release];
	[FlickriumPluginPrefs release];
	[[adium contentController] unregisterHTMLContentFilter:self];
}

- (float)filterPriority
{
	return LOW_FILTER_PRIORITY; // We must be processed _after_ linkify
}

- (NSString *)filterHTMLString:(NSString *)inHTMLString content:(AIContentObject *)content
{
	// TODO: odwrocic
	NSLog(@"flickrium enabled: %@", [[adium preferenceController] preferenceForKey:KEY_FLICKRIUM_ENABLED group:PREF_GROUP_FLICKRIUM]);
	if (content.isOutgoing)// && [[[adium preferenceController] preferenceForKey:KEY_FLICKRIUM_ENABLED
						   //											 group:PREF_GROUP_FLICKRIUM] boolValue])
	{		
		NSMutableString *newMessage = [[[NSMutableString alloc] initWithString:inHTMLString] autorelease];
		
		//NSArray *capturesArray = [inHTMLString arrayOfCaptureComponentsMatchedByRegex:FLICKR_URL_REGEX];
		NSArray *capturesArray = [inHTMLString arrayOfCaptureFlickrUrls];
		if ([capturesArray count] > 0) {
			
			NSLog(@"body: %@", inHTMLString);
			
			id capturedArray;
			NSMutableArray *photosArray = [NSMutableArray arrayWithCapacity:[capturesArray count]];
			NSEnumerator *rxenum = [capturesArray objectEnumerator];
			while (capturedArray = [rxenum nextObject]) {
				NSLog(@"caputredArray: %@", capturedArray);
				NSLog(@"capturedArray[1]: %@", [capturedArray objectAtIndex:1]);
				if ([capturedArray count] == 2) {
					
					if (![photosArray containsObject:[capturedArray objectAtIndex:1]]) {
						NSLog(@"Adding %@ to photosArray", [capturedArray objectAtIndex:1]);
						[photosArray addObject:[capturedArray objectAtIndex:1]];
						
						// Dodajemy brejk lanja jeśli są jakieś foty, który oddzieli treść od miniaturek
						if ([photosArray count] == 1){
							[newMessage appendString:@"<br />"];
						}
						
						photoCounter++;
						// Ok, teraz mozna gdzies podstawic flickriumJs
						[newMessage appendString:
						 [NSString stringWithFormat:
						  @"<script>_current_element_id = \"photo_%d\"; %@</script>", photoCounter, flickriumJs]];
						// ciekawe czy jest cos takiego jak obiekt window - zawsze to jakies ciekawe miejsce na zmienne globalne
						[newMessage appendString:
						 [NSString stringWithFormat:
						  @"Photo %d <a id=\"photo_%d\" href=\"http://api.flickr.com/services/rest/?method=flickr.photos.getSizes&api_key=%@&photo_id=%@&format=json\">Click</a><br />", 
						  photoCounter, photoCounter, OBJECTIVE_FLICKR_SAMPLE_API_KEY, [capturedArray objectAtIndex:1]]];
						
						[newMessage appendString:
						 [NSString stringWithFormat:
						  @"<script src=\"http://api.flickr.com/services/rest/?method=flickr.photos.getSizes&api_key=%@&photo_id=%@&format=json\"></script>",
						  OBJECTIVE_FLICKR_SAMPLE_API_KEY, [capturedArray objectAtIndex:1]]];
						
						NSLog(@"newString: %@", newMessage);
					}
					
				} else {
					NSLog(@"Invalid capturedArray: %@", capturedArray);
				}
			}
		}
		return newMessage;
	}	
	return inHTMLString;
}

// Example: http://www.flickr.com/photos/matee/3129103590
// Example: http://www.flickr.com/photos/matee/3129103590/
// Example: http://www.flickr.com/photos/30891225@N04/4283899764/
// Example: http://www.flickr.com/photos/30891225@N04/4286685346/in/set-72157615338688530/
// Example: http://www.flickr.com/photos/40659122@N08/4276353029/in/pool-bangladeshiphotographers/


@end
